//+---------------------------------------------------------------------+
//|                                                      XR-Squared.mq5 | 
//|                                Copyright  2011,   Nikolay Kositsin | 
//|                                 Khabarovsk,   farria@mail.redcom.ru | 
//+---------------------------------------------------------------------+
//|          SmoothAlgorithms.mqh |
//|   (): terminal_data_folder\MQL5\Include             |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2011, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
#property description "R-Squared"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----    2
#property indicator_buffers 2 
//----     
#property indicator_plots   2
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_LINE
//----        DeepPink
#property indicator_color1 DeepPink
//----   -  
#property indicator_style1  STYLE_SOLID
//----     1
#property indicator_width1  1
//----   
#property indicator_label1  "R-Squared"
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type2   DRAW_LINE
//----        DodgerBlue
#property indicator_color2 DodgerBlue
//----   - -
#property indicator_style2  STYLE_DASHDOTDOT
//----     1
#property indicator_width2  1
//----   
#property indicator_label2  "Signal"
//+----------------------------------------------+
//|     |
//+----------------------------------------------+
#property indicator_level1       70.0
#property indicator_level2       30.0
#property indicator_levelcolor DarkOrchid
#property indicator_levelstyle STYLE_DASHDOTDOT
//+-----------------------------------+
//|    CXMA             |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+
//----    CXMA   SmoothAlgorithms.mqh
CXMA XMA;
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum Applied_price_ //  
  {
   PRICE_CLOSE_ = 1,     // Close
   PRICE_OPEN_,          // Open
   PRICE_HIGH_,          // High
   PRICE_LOW_,           // Low
   PRICE_MEDIAN_,        // Median Price (HL/2)
   PRICE_TYPICAL_,       // Typical Price (HLC/3)
   PRICE_WEIGHTED_,      // Weighted Close (HLCC/4)
   PRICE_SIMPLE,         // Simple Price (OC/2)
   PRICE_QUARTER_,       // Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  // TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   // TrendFollow_2 Price 
  };
/*enum Smooth_Method -    SmoothAlgorithms.mqh
  {
   MODE_SMA_,  // SMA
   MODE_EMA_,  // EMA
   MODE_SMMA_, // SMMA
   MODE_LWMA_, // LWMA
   MODE_JJMA,  // JJMA
   MODE_JurX,  // JurX
   MODE_ParMA, // ParMA
   MODE_T3,    // T3
   MODE_VIDYA, // VIDYA
   MODE_AMA,   // AMA
  }; */
//+-----------------------------------+
//|         |
//+-----------------------------------+
input int XPeriod=14;                    //  
input Smooth_Method RMethod=MODE_JJMA;   //  
input int RPeriod=3;                     //  
input int RPhase=100;                    //  
input Smooth_Method SignMethod=MODE_SMA; //   
input int SignPeriod=14;                 //    
input int SignPhase=15;                  //  
input Applied_price_ IPC=PRICE_CLOSE;    //  
input int Shift=0;                       //      
//+-----------------------------------+
//----   ,   
//----      
double RSquared[],XRSquared[];
//----      
int StartBars,StartBarsR,StartBarsX;
//----   ,   
//----      
int Count[];
double MA[];
//----
int SumX,SumX2;
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+   
void Recount_ArrayZeroPos(int &CoArr[], //        
                          int Size)     //     
  {
//----
   int numb,Max1,Max2;
   static int count=1;

   Max2=Size;
   Max1=Max2-1;

   count--;
   if(count<0) count=Max1;

   for(int iii=0; iii<Max2; iii++)
     {
      numb=iii+count;
      if(numb>Max1) numb-=Max2;
      CoArr[iii]=numb;
     }
//----
  }
//+------------------------------------------------------------------+   
//| XR-Squared indicator initialization function                     | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----     
   StartBarsR=XMA.GetStartBars(RMethod,RPeriod,RPhase)+1;
   StartBarsX=StartBarsR+XPeriod+1;
   StartBars=StartBarsX+XMA.GetStartBars(SignMethod,SignPeriod,SignPhase);

//----       
   XMA.XMALengthCheck("SignPeriod",SignPeriod);
   XMA.XMAPhaseCheck("SignPhase",SignPhase,SignMethod);

//----       
   XMA.XMALengthCheck("RPeriod",RPeriod);
   XMA.XMAPhaseCheck("RPhase",RPhase,RMethod);

//----       
   ArrayResize(Count,XPeriod);
   ArrayResize(MA,XPeriod);

//----   
   ArrayInitialize(Count,0);
   ArrayInitialize(MA,0.0);

//----    
   SumX=0;
   for(int iii=0; iii<XPeriod; iii++) SumX+=iii+1;

   SumX2=0;
   for(int iii=0; iii<XPeriod; iii++) SumX2+=(iii+1)*(iii+1);

//----    RSquared   
   SetIndexBuffer(0,RSquared,INDICATOR_DATA);
//----    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,RPeriod);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----    XRSquared   
   SetIndexBuffer(1,XRSquared,INDICATOR_DATA);
//----    1  
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,StartBars);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----      
   string shortname,Smooth;
   Smooth=XMA.GetString_MA_Method(SignMethod);
   StringConcatenate(shortname,"XR-Squared(",string(RPeriod),",",Smooth,")");
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);

//---     
   IndicatorSetInteger(INDICATOR_DIGITS,2);
//----  
  }
//+------------------------------------------------------------------+ 
//| XRSI iteration function                                          | 
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(rates_total<StartBars) return(0);

//----       
   double price_,SumY,SumY2,SumXY,Q1,Q2,Q3,Q23;
//----        
   int first,bar;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      first=0;
   else first=prev_calculated-1; //      

//----    
   for(bar=first; bar<rates_total; bar++)
     {
      //----   PriceSeries      dprice_
      price_=PriceSeries(IPC,bar,open,low,high,close);
      MA[Count[0]]=XMA.XMASeries(0,prev_calculated,rates_total,RMethod,RPhase,RPeriod,price_,bar,false);

      if(bar<StartBarsX)
        {
         //----       Smooth[]
         if(bar<rates_total-2) Recount_ArrayZeroPos(Count,XPeriod);
         continue;
        }

      SumY=0;
      for(int iii=0; iii<XPeriod; iii++) SumY+=MA[Count[iii]];

      SumY2=0;
      for(int iii=0; iii<XPeriod; iii++) SumY2+=MathPow(MA[Count[iii]],2);

      SumXY=0;
      for(int iii=0; iii<XPeriod; iii++) SumXY+=(iii+1)*MA[Count[iii]];

      Q1=SumXY-SumX*SumY/XPeriod;
      Q2=SumX2-SumX*SumX/XPeriod;
      Q3=SumY2-SumY*SumY/XPeriod;
      Q23=Q2*Q3;

      if(Q23) RSquared[bar] = 100*Q1*Q1/(Q23);
      else    RSquared[bar] = 0.0;

      //----
      // XRSquared[bar]=XMA.XMASeries(StartBarsX,prev_calculated,rates_total,SignMethod,SignPhase,SignPeriod,RSquared[bar],bar,false);

      //----       Smooth[]
      if(bar<rates_total-2) Recount_ArrayZeroPos(Count,XPeriod);
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
